package com.sjkj.appthreefloor_tsgz.net;

import android.content.Context;

import com.sjkj.appthreefloor_tsgz.bean.ResourceVisualizationBean;
import com.sjkj.base_lib.entity.Params;
import com.sjkj.base_lib.entity.ResponseBean;
import com.sjkj.base_lib.net.RetrofitFactory;
import com.sjkj.base_lib.net.data.exception.BusinessException;
import com.sjkj.base_lib.net.domain.interactor.UseCase;
import com.sjkj.base_lib.utils.AppTools;

import java.util.List;

import rx.Observable;
import rx.functions.Func1;

/**
 * 获取数据中心列表
 * 2版统一用一个接口
 */
public class NewDataCenterRequest extends UseCase {
    private Context context;
    private RetrofitService service;

    private Params params;

    public Params getParams() {
        return params;
    }

    public void setParams(Params params) {
        this.params = params;
    }

    public NewDataCenterRequest(Context context) {
        this.context = context;
        service = RetrofitFactory.getRetrofit(AppTools.getBaseUrl()).create(RetrofitService.class);
    }

    @Override
    protected Observable buildUseCaseObservable() {
        return service.GetNEWDATA(params).flatMap(new Func1<ResponseBean<List<ResourceVisualizationBean>>, Observable<List<ResourceVisualizationBean>>>() {
            @Override
            public Observable<List<ResourceVisualizationBean>> call(ResponseBean<List<ResourceVisualizationBean>> responseBean) {
                if (!ResponseBean.CODE_SUCCESS.
                        equals(responseBean.getCode())) {
                    return Observable.error(new BusinessException(responseBean.getMsg()));
                }
                return Observable.just(responseBean.getData());
            }
        });
    }
}
